<?php
// auto-generated by sfPropelAdmin
// date: 2007/03/28 18:10:44
?>
<?php

/**
 * autoUser actions.
 *
 * @package    ##PROJECT_NAME##
 * @subpackage autoUser
 * @author     Fabien Potencier <fabien.potencier@symfony-project.com>
 * @version    SVN: $Id: actions.class.php 3501 2007-02-18 10:28:17Z fabien $
 */
class autoUserActions extends sfActions
{
  public function executeIndex()
  {
    return $this->forward('user', 'list');
  }

  public function executeList()
  {
    $this->processSort();

    $this->processFilters();


    // pager
    $this->pager = new sfPropelPager('Users', 20);
    $c = new Criteria();
    $this->addSortCriteria($c);
    $this->addFiltersCriteria($c);
    $this->pager->setCriteria($c);
    $this->pager->setPage($this->getRequestParameter('page', 1));
    $this->pager->init();
  }

  public function executeCreate()
  {
    return $this->forward('user', 'edit');
  }

  public function executeSave()
  {
    return $this->forward('user', 'edit');
  }

  public function executeEdit()
  {
    $this->users = $this->getUsersOrCreate();

    if ($this->getRequest()->getMethod() == sfRequest::POST)
    {
      $this->updateUsersFromRequest();

      $this->saveUsers($this->users);

      $this->setFlash('notice', 'Your modifications have been saved');

      if ($this->getRequestParameter('save_and_add'))
      {
        return $this->redirect('user/create');
      }
      else if ($this->getRequestParameter('save_and_list'))
      {
        return $this->redirect('user/list');
      }
      else
      {
        return $this->redirect('user/edit?id='.$this->users->getId());
      }
    }
    else
    {
      $this->labels = $this->getLabels();
    }
  }

  public function executeDelete()
  {
    $this->users = UsersPeer::retrieveByPk($this->getRequestParameter('id'));
    $this->forward404Unless($this->users);

    try
    {
      $this->deleteUsers($this->users);
    }
    catch (PropelException $e)
    {
      $this->getRequest()->setError('delete', 'Could not delete the selected Users. Make sure it does not have any associated items.');
      return $this->forward('user', 'list');
    }

    return $this->redirect('user/list');
  }

  public function handleErrorEdit()
  {
    $this->preExecute();
    $this->users = $this->getUsersOrCreate();
    $this->updateUsersFromRequest();

    $this->labels = $this->getLabels();

    return sfView::SUCCESS;
  }

  protected function saveUsers($users)
  {
    $users->save();

  }

  protected function deleteUsers($users)
  {
    $users->delete();
  }

  protected function updateUsersFromRequest()
  {
    $users = $this->getRequestParameter('users');

    if (isset($users['username']))
    {
      $this->users->setUsername($users['username']);
    }
    if (isset($users['password']))
    {
      $this->users->setPassword($users['password']);
    }
  }

  protected function getUsersOrCreate($id = 'id')
  {
    if (!$this->getRequestParameter($id))
    {
      $users = new Users();
    }
    else
    {
      $users = UsersPeer::retrieveByPk($this->getRequestParameter($id));

      $this->forward404Unless($users);
    }

    return $users;
  }

  protected function processFilters()
  {
  }

  protected function processSort()
  {
    if ($this->getRequestParameter('sort'))
    {
      $this->getUser()->setAttribute('sort', $this->getRequestParameter('sort'), 'sf_admin/users/sort');
      $this->getUser()->setAttribute('type', $this->getRequestParameter('type', 'asc'), 'sf_admin/users/sort');
    }

    if (!$this->getUser()->getAttribute('sort', null, 'sf_admin/users/sort'))
    {
    }
  }

  protected function addFiltersCriteria($c)
  {
  }

  protected function addSortCriteria($c)
  {
    if ($sort_column = $this->getUser()->getAttribute('sort', null, 'sf_admin/users/sort'))
    {
      $sort_column = UsersPeer::translateFieldName($sort_column, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_COLNAME);
      if ($this->getUser()->getAttribute('type', null, 'sf_admin/users/sort') == 'asc')
      {
        $c->addAscendingOrderByColumn($sort_column);
      }
      else
      {
        $c->addDescendingOrderByColumn($sort_column);
      }
    }
  }

  protected function getLabels()
  {
    return array(
      'users{id}' => 'Id:',
      'users{username}' => 'Username:',
      'users{password}' => 'Password:',
    );
  }
}
